// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: device.proto

#include "device.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)
namespace mascot {
class GetAttributeListMessageDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<GetAttributeListMessage>
      _instance;
} _GetAttributeListMessage_default_instance_;
class GetCommandListMessageDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<GetCommandListMessage>
      _instance;
} _GetCommandListMessage_default_instance_;
class DeviceAttributeDescriptionDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceAttributeDescription>
      _instance;
} _DeviceAttributeDescription_default_instance_;
class AttributeListReplyDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<AttributeListReply>
      _instance;
} _AttributeListReply_default_instance_;
class DeviceCommandDescription_ParametersEntry_DoNotUseDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceCommandDescription_ParametersEntry_DoNotUse>
      _instance;
} _DeviceCommandDescription_ParametersEntry_DoNotUse_default_instance_;
class DeviceCommandDescription_ReturnValuesEntry_DoNotUseDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceCommandDescription_ReturnValuesEntry_DoNotUse>
      _instance;
} _DeviceCommandDescription_ReturnValuesEntry_DoNotUse_default_instance_;
class DeviceCommandDescriptionDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<DeviceCommandDescription>
      _instance;
} _DeviceCommandDescription_default_instance_;
class CommandListReplyDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<CommandListReply>
      _instance;
} _CommandListReply_default_instance_;
}  // namespace mascot
namespace protobuf_device_2eproto {
void InitDefaultsGetAttributeListMessageImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_GetAttributeListMessage_default_instance_;
    new (ptr) ::mascot::GetAttributeListMessage();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::GetAttributeListMessage::InitAsDefaultInstance();
}

void InitDefaultsGetAttributeListMessage() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsGetAttributeListMessageImpl);
}

void InitDefaultsGetCommandListMessageImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_GetCommandListMessage_default_instance_;
    new (ptr) ::mascot::GetCommandListMessage();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::GetCommandListMessage::InitAsDefaultInstance();
}

void InitDefaultsGetCommandListMessage() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsGetCommandListMessageImpl);
}

void InitDefaultsDeviceAttributeDescriptionImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_DeviceAttributeDescription_default_instance_;
    new (ptr) ::mascot::DeviceAttributeDescription();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DeviceAttributeDescription::InitAsDefaultInstance();
}

void InitDefaultsDeviceAttributeDescription() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDeviceAttributeDescriptionImpl);
}

void InitDefaultsAttributeListReplyImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_device_2eproto::InitDefaultsDeviceAttributeDescription();
  {
    void* ptr = &::mascot::_AttributeListReply_default_instance_;
    new (ptr) ::mascot::AttributeListReply();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::AttributeListReply::InitAsDefaultInstance();
}

void InitDefaultsAttributeListReply() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsAttributeListReplyImpl);
}

void InitDefaultsDeviceCommandDescription_ParametersEntry_DoNotUseImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_DeviceCommandDescription_ParametersEntry_DoNotUse_default_instance_;
    new (ptr) ::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse();
  }
  ::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse::InitAsDefaultInstance();
}

void InitDefaultsDeviceCommandDescription_ParametersEntry_DoNotUse() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDeviceCommandDescription_ParametersEntry_DoNotUseImpl);
}

void InitDefaultsDeviceCommandDescription_ReturnValuesEntry_DoNotUseImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_DeviceCommandDescription_ReturnValuesEntry_DoNotUse_default_instance_;
    new (ptr) ::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse();
  }
  ::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse::InitAsDefaultInstance();
}

void InitDefaultsDeviceCommandDescription_ReturnValuesEntry_DoNotUse() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDeviceCommandDescription_ReturnValuesEntry_DoNotUseImpl);
}

void InitDefaultsDeviceCommandDescriptionImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_device_2eproto::InitDefaultsDeviceCommandDescription_ParametersEntry_DoNotUse();
  protobuf_device_2eproto::InitDefaultsDeviceCommandDescription_ReturnValuesEntry_DoNotUse();
  {
    void* ptr = &::mascot::_DeviceCommandDescription_default_instance_;
    new (ptr) ::mascot::DeviceCommandDescription();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::DeviceCommandDescription::InitAsDefaultInstance();
}

void InitDefaultsDeviceCommandDescription() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsDeviceCommandDescriptionImpl);
}

void InitDefaultsCommandListReplyImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_device_2eproto::InitDefaultsDeviceCommandDescription();
  {
    void* ptr = &::mascot::_CommandListReply_default_instance_;
    new (ptr) ::mascot::CommandListReply();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::CommandListReply::InitAsDefaultInstance();
}

void InitDefaultsCommandListReply() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsCommandListReplyImpl);
}

::google::protobuf::Metadata file_level_metadata[8];

const ::google::protobuf::uint32 TableStruct::offsets[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::GetAttributeListMessage, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::GetCommandListMessage, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeDescription, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeDescription, name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeDescription, datatype_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceAttributeDescription, writable_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeListReply, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeListReply, attributes_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse, key_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse, value_),
  0,
  1,
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse, key_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse, value_),
  0,
  1,
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription, name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription, parameters_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::DeviceCommandDescription, returnvalues_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::CommandListReply, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::CommandListReply, commands_),
};
static const ::google::protobuf::internal::MigrationSchema schemas[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  { 0, -1, sizeof(::mascot::GetAttributeListMessage)},
  { 5, -1, sizeof(::mascot::GetCommandListMessage)},
  { 10, -1, sizeof(::mascot::DeviceAttributeDescription)},
  { 18, -1, sizeof(::mascot::AttributeListReply)},
  { 24, 31, sizeof(::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse)},
  { 33, 40, sizeof(::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse)},
  { 42, -1, sizeof(::mascot::DeviceCommandDescription)},
  { 50, -1, sizeof(::mascot::CommandListReply)},
};

static ::google::protobuf::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_GetAttributeListMessage_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_GetCommandListMessage_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceAttributeDescription_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_AttributeListReply_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceCommandDescription_ParametersEntry_DoNotUse_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceCommandDescription_ReturnValuesEntry_DoNotUse_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_DeviceCommandDescription_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_CommandListReply_default_instance_),
};

void protobuf_AssignDescriptors() {
  AddDescriptors();
  ::google::protobuf::MessageFactory* factory = NULL;
  AssignDescriptors(
      "device.proto", schemas, file_default_instances, TableStruct::offsets, factory,
      file_level_metadata, NULL, NULL);
}

void protobuf_AssignDescriptorsOnce() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &protobuf_AssignDescriptors);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_PROTOBUF_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::internal::RegisterAllTypes(file_level_metadata, 8);
}

void AddDescriptorsImpl() {
  InitDefaults();
  static const char descriptor[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
      "\n\014device.proto\022\006mascot\032\021tango_enums.prot"
      "o\"\031\n\027GetAttributeListMessage\"\027\n\025GetComma"
      "ndListMessage\"b\n\032DeviceAttributeDescript"
      "ion\022\014\n\004name\030\001 \001(\t\022$\n\010dataType\030\002 \001(\0162\022.ma"
      "scot.CmdArgType\022\020\n\010writable\030\003 \001(\010\"L\n\022Att"
      "ributeListReply\0226\n\nattributes\030\001 \003(\0132\".ma"
      "scot.DeviceAttributeDescription\"\310\002\n\030Devi"
      "ceCommandDescription\022\014\n\004name\030\001 \001(\t\022D\n\npa"
      "rameters\030\002 \003(\01320.mascot.DeviceCommandDes"
      "cription.ParametersEntry\022H\n\014returnValues"
      "\030\003 \003(\01322.mascot.DeviceCommandDescription"
      ".ReturnValuesEntry\032E\n\017ParametersEntry\022\013\n"
      "\003key\030\001 \001(\t\022!\n\005value\030\002 \001(\0162\022.mascot.CmdAr"
      "gType:\0028\001\032G\n\021ReturnValuesEntry\022\013\n\003key\030\001 "
      "\001(\t\022!\n\005value\030\002 \001(\0162\022.mascot.CmdArgType:\002"
      "8\001\"F\n\020CommandListReply\0222\n\010commands\030\001 \003(\013"
      "2 .mascot.DeviceCommandDescriptionb\006prot"
      "o3"
  };
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
      descriptor, 682);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "device.proto", &protobuf_RegisterTypes);
  ::protobuf_tango_5fenums_2eproto::AddDescriptors();
}

void AddDescriptors() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &AddDescriptorsImpl);
}
// Force AddDescriptors() to be called at dynamic initialization time.
struct StaticDescriptorInitializer {
  StaticDescriptorInitializer() {
    AddDescriptors();
  }
} static_descriptor_initializer;
}  // namespace protobuf_device_2eproto
namespace mascot {

// ===================================================================

void GetAttributeListMessage::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

GetAttributeListMessage::GetAttributeListMessage()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_2eproto::InitDefaultsGetAttributeListMessage();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.GetAttributeListMessage)
}
GetAttributeListMessage::GetAttributeListMessage(const GetAttributeListMessage& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.GetAttributeListMessage)
}

void GetAttributeListMessage::SharedCtor() {
  _cached_size_ = 0;
}

GetAttributeListMessage::~GetAttributeListMessage() {
  // @@protoc_insertion_point(destructor:mascot.GetAttributeListMessage)
  SharedDtor();
}

void GetAttributeListMessage::SharedDtor() {
}

void GetAttributeListMessage::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* GetAttributeListMessage::descriptor() {
  ::protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const GetAttributeListMessage& GetAttributeListMessage::default_instance() {
  ::protobuf_device_2eproto::InitDefaultsGetAttributeListMessage();
  return *internal_default_instance();
}

GetAttributeListMessage* GetAttributeListMessage::New(::google::protobuf::Arena* arena) const {
  GetAttributeListMessage* n = new GetAttributeListMessage;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void GetAttributeListMessage::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.GetAttributeListMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  _internal_metadata_.Clear();
}

bool GetAttributeListMessage::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.GetAttributeListMessage)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
  handle_unusual:
    if (tag == 0) {
      goto success;
    }
    DO_(::google::protobuf::internal::WireFormat::SkipField(
          input, tag, _internal_metadata_.mutable_unknown_fields()));
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.GetAttributeListMessage)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.GetAttributeListMessage)
  return false;
#undef DO_
}

void GetAttributeListMessage::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.GetAttributeListMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.GetAttributeListMessage)
}

::google::protobuf::uint8* GetAttributeListMessage::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.GetAttributeListMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.GetAttributeListMessage)
  return target;
}

size_t GetAttributeListMessage::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.GetAttributeListMessage)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void GetAttributeListMessage::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.GetAttributeListMessage)
  GOOGLE_DCHECK_NE(&from, this);
  const GetAttributeListMessage* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const GetAttributeListMessage>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.GetAttributeListMessage)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.GetAttributeListMessage)
    MergeFrom(*source);
  }
}

void GetAttributeListMessage::MergeFrom(const GetAttributeListMessage& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.GetAttributeListMessage)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

}

void GetAttributeListMessage::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.GetAttributeListMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void GetAttributeListMessage::CopyFrom(const GetAttributeListMessage& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.GetAttributeListMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool GetAttributeListMessage::IsInitialized() const {
  return true;
}

void GetAttributeListMessage::Swap(GetAttributeListMessage* other) {
  if (other == this) return;
  InternalSwap(other);
}
void GetAttributeListMessage::InternalSwap(GetAttributeListMessage* other) {
  using std::swap;
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata GetAttributeListMessage::GetMetadata() const {
  protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void GetCommandListMessage::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

GetCommandListMessage::GetCommandListMessage()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_2eproto::InitDefaultsGetCommandListMessage();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.GetCommandListMessage)
}
GetCommandListMessage::GetCommandListMessage(const GetCommandListMessage& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.GetCommandListMessage)
}

void GetCommandListMessage::SharedCtor() {
  _cached_size_ = 0;
}

GetCommandListMessage::~GetCommandListMessage() {
  // @@protoc_insertion_point(destructor:mascot.GetCommandListMessage)
  SharedDtor();
}

void GetCommandListMessage::SharedDtor() {
}

void GetCommandListMessage::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* GetCommandListMessage::descriptor() {
  ::protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const GetCommandListMessage& GetCommandListMessage::default_instance() {
  ::protobuf_device_2eproto::InitDefaultsGetCommandListMessage();
  return *internal_default_instance();
}

GetCommandListMessage* GetCommandListMessage::New(::google::protobuf::Arena* arena) const {
  GetCommandListMessage* n = new GetCommandListMessage;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void GetCommandListMessage::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.GetCommandListMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  _internal_metadata_.Clear();
}

bool GetCommandListMessage::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.GetCommandListMessage)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
  handle_unusual:
    if (tag == 0) {
      goto success;
    }
    DO_(::google::protobuf::internal::WireFormat::SkipField(
          input, tag, _internal_metadata_.mutable_unknown_fields()));
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.GetCommandListMessage)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.GetCommandListMessage)
  return false;
#undef DO_
}

void GetCommandListMessage::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.GetCommandListMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.GetCommandListMessage)
}

::google::protobuf::uint8* GetCommandListMessage::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.GetCommandListMessage)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.GetCommandListMessage)
  return target;
}

size_t GetCommandListMessage::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.GetCommandListMessage)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void GetCommandListMessage::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.GetCommandListMessage)
  GOOGLE_DCHECK_NE(&from, this);
  const GetCommandListMessage* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const GetCommandListMessage>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.GetCommandListMessage)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.GetCommandListMessage)
    MergeFrom(*source);
  }
}

void GetCommandListMessage::MergeFrom(const GetCommandListMessage& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.GetCommandListMessage)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

}

void GetCommandListMessage::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.GetCommandListMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void GetCommandListMessage::CopyFrom(const GetCommandListMessage& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.GetCommandListMessage)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool GetCommandListMessage::IsInitialized() const {
  return true;
}

void GetCommandListMessage::Swap(GetCommandListMessage* other) {
  if (other == this) return;
  InternalSwap(other);
}
void GetCommandListMessage::InternalSwap(GetCommandListMessage* other) {
  using std::swap;
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata GetCommandListMessage::GetMetadata() const {
  protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void DeviceAttributeDescription::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DeviceAttributeDescription::kNameFieldNumber;
const int DeviceAttributeDescription::kDataTypeFieldNumber;
const int DeviceAttributeDescription::kWritableFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DeviceAttributeDescription::DeviceAttributeDescription()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_2eproto::InitDefaultsDeviceAttributeDescription();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DeviceAttributeDescription)
}
DeviceAttributeDescription::DeviceAttributeDescription(const DeviceAttributeDescription& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.name().size() > 0) {
    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  ::memcpy(&datatype_, &from.datatype_,
    static_cast<size_t>(reinterpret_cast<char*>(&writable_) -
    reinterpret_cast<char*>(&datatype_)) + sizeof(writable_));
  // @@protoc_insertion_point(copy_constructor:mascot.DeviceAttributeDescription)
}

void DeviceAttributeDescription::SharedCtor() {
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  ::memset(&datatype_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&writable_) -
      reinterpret_cast<char*>(&datatype_)) + sizeof(writable_));
  _cached_size_ = 0;
}

DeviceAttributeDescription::~DeviceAttributeDescription() {
  // @@protoc_insertion_point(destructor:mascot.DeviceAttributeDescription)
  SharedDtor();
}

void DeviceAttributeDescription::SharedDtor() {
  name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void DeviceAttributeDescription::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DeviceAttributeDescription::descriptor() {
  ::protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DeviceAttributeDescription& DeviceAttributeDescription::default_instance() {
  ::protobuf_device_2eproto::InitDefaultsDeviceAttributeDescription();
  return *internal_default_instance();
}

DeviceAttributeDescription* DeviceAttributeDescription::New(::google::protobuf::Arena* arena) const {
  DeviceAttributeDescription* n = new DeviceAttributeDescription;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DeviceAttributeDescription::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DeviceAttributeDescription)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  ::memset(&datatype_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&writable_) -
      reinterpret_cast<char*>(&datatype_)) + sizeof(writable_));
  _internal_metadata_.Clear();
}

bool DeviceAttributeDescription::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DeviceAttributeDescription)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string name = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_name()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->name().data(), static_cast<int>(this->name().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceAttributeDescription.name"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.CmdArgType dataType = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          set_datatype(static_cast< ::mascot::CmdArgType >(value));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // bool writable = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &writable_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DeviceAttributeDescription)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DeviceAttributeDescription)
  return false;
#undef DO_
}

void DeviceAttributeDescription::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DeviceAttributeDescription)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceAttributeDescription.name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->name(), output);
  }

  // .mascot.CmdArgType dataType = 2;
  if (this->datatype() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      2, this->datatype(), output);
  }

  // bool writable = 3;
  if (this->writable() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(3, this->writable(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DeviceAttributeDescription)
}

::google::protobuf::uint8* DeviceAttributeDescription::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DeviceAttributeDescription)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceAttributeDescription.name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->name(), target);
  }

  // .mascot.CmdArgType dataType = 2;
  if (this->datatype() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteEnumToArray(
      2, this->datatype(), target);
  }

  // bool writable = 3;
  if (this->writable() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(3, this->writable(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DeviceAttributeDescription)
  return target;
}

size_t DeviceAttributeDescription::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DeviceAttributeDescription)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string name = 1;
  if (this->name().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->name());
  }

  // .mascot.CmdArgType dataType = 2;
  if (this->datatype() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->datatype());
  }

  // bool writable = 3;
  if (this->writable() != 0) {
    total_size += 1 + 1;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DeviceAttributeDescription::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DeviceAttributeDescription)
  GOOGLE_DCHECK_NE(&from, this);
  const DeviceAttributeDescription* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DeviceAttributeDescription>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DeviceAttributeDescription)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DeviceAttributeDescription)
    MergeFrom(*source);
  }
}

void DeviceAttributeDescription::MergeFrom(const DeviceAttributeDescription& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DeviceAttributeDescription)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.name().size() > 0) {

    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  if (from.datatype() != 0) {
    set_datatype(from.datatype());
  }
  if (from.writable() != 0) {
    set_writable(from.writable());
  }
}

void DeviceAttributeDescription::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DeviceAttributeDescription)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DeviceAttributeDescription::CopyFrom(const DeviceAttributeDescription& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DeviceAttributeDescription)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DeviceAttributeDescription::IsInitialized() const {
  return true;
}

void DeviceAttributeDescription::Swap(DeviceAttributeDescription* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DeviceAttributeDescription::InternalSwap(DeviceAttributeDescription* other) {
  using std::swap;
  name_.Swap(&other->name_);
  swap(datatype_, other->datatype_);
  swap(writable_, other->writable_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DeviceAttributeDescription::GetMetadata() const {
  protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void AttributeListReply::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int AttributeListReply::kAttributesFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

AttributeListReply::AttributeListReply()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_2eproto::InitDefaultsAttributeListReply();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.AttributeListReply)
}
AttributeListReply::AttributeListReply(const AttributeListReply& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      attributes_(from.attributes_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.AttributeListReply)
}

void AttributeListReply::SharedCtor() {
  _cached_size_ = 0;
}

AttributeListReply::~AttributeListReply() {
  // @@protoc_insertion_point(destructor:mascot.AttributeListReply)
  SharedDtor();
}

void AttributeListReply::SharedDtor() {
}

void AttributeListReply::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* AttributeListReply::descriptor() {
  ::protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const AttributeListReply& AttributeListReply::default_instance() {
  ::protobuf_device_2eproto::InitDefaultsAttributeListReply();
  return *internal_default_instance();
}

AttributeListReply* AttributeListReply::New(::google::protobuf::Arena* arena) const {
  AttributeListReply* n = new AttributeListReply;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void AttributeListReply::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.AttributeListReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  attributes_.Clear();
  _internal_metadata_.Clear();
}

bool AttributeListReply::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.AttributeListReply)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .mascot.DeviceAttributeDescription attributes = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(input, add_attributes()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.AttributeListReply)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.AttributeListReply)
  return false;
#undef DO_
}

void AttributeListReply::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.AttributeListReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.DeviceAttributeDescription attributes = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->attributes_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->attributes(static_cast<int>(i)), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.AttributeListReply)
}

::google::protobuf::uint8* AttributeListReply::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.AttributeListReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.DeviceAttributeDescription attributes = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->attributes_size()); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        1, this->attributes(static_cast<int>(i)), deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.AttributeListReply)
  return target;
}

size_t AttributeListReply::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.AttributeListReply)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated .mascot.DeviceAttributeDescription attributes = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->attributes_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->attributes(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void AttributeListReply::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.AttributeListReply)
  GOOGLE_DCHECK_NE(&from, this);
  const AttributeListReply* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const AttributeListReply>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.AttributeListReply)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.AttributeListReply)
    MergeFrom(*source);
  }
}

void AttributeListReply::MergeFrom(const AttributeListReply& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.AttributeListReply)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  attributes_.MergeFrom(from.attributes_);
}

void AttributeListReply::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.AttributeListReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void AttributeListReply::CopyFrom(const AttributeListReply& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.AttributeListReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool AttributeListReply::IsInitialized() const {
  return true;
}

void AttributeListReply::Swap(AttributeListReply* other) {
  if (other == this) return;
  InternalSwap(other);
}
void AttributeListReply::InternalSwap(AttributeListReply* other) {
  using std::swap;
  attributes_.InternalSwap(&other->attributes_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata AttributeListReply::GetMetadata() const {
  protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

DeviceCommandDescription_ParametersEntry_DoNotUse::DeviceCommandDescription_ParametersEntry_DoNotUse() {}
DeviceCommandDescription_ParametersEntry_DoNotUse::DeviceCommandDescription_ParametersEntry_DoNotUse(::google::protobuf::Arena* arena) : SuperType(arena) {}
void DeviceCommandDescription_ParametersEntry_DoNotUse::MergeFrom(const DeviceCommandDescription_ParametersEntry_DoNotUse& other) {
  MergeFromInternal(other);
}
::google::protobuf::Metadata DeviceCommandDescription_ParametersEntry_DoNotUse::GetMetadata() const {
  ::protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[4];
}
void DeviceCommandDescription_ParametersEntry_DoNotUse::MergeFrom(
    const ::google::protobuf::Message& other) {
  ::google::protobuf::Message::MergeFrom(other);
}


// ===================================================================

DeviceCommandDescription_ReturnValuesEntry_DoNotUse::DeviceCommandDescription_ReturnValuesEntry_DoNotUse() {}
DeviceCommandDescription_ReturnValuesEntry_DoNotUse::DeviceCommandDescription_ReturnValuesEntry_DoNotUse(::google::protobuf::Arena* arena) : SuperType(arena) {}
void DeviceCommandDescription_ReturnValuesEntry_DoNotUse::MergeFrom(const DeviceCommandDescription_ReturnValuesEntry_DoNotUse& other) {
  MergeFromInternal(other);
}
::google::protobuf::Metadata DeviceCommandDescription_ReturnValuesEntry_DoNotUse::GetMetadata() const {
  ::protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[5];
}
void DeviceCommandDescription_ReturnValuesEntry_DoNotUse::MergeFrom(
    const ::google::protobuf::Message& other) {
  ::google::protobuf::Message::MergeFrom(other);
}


// ===================================================================

void DeviceCommandDescription::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int DeviceCommandDescription::kNameFieldNumber;
const int DeviceCommandDescription::kParametersFieldNumber;
const int DeviceCommandDescription::kReturnValuesFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

DeviceCommandDescription::DeviceCommandDescription()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_2eproto::InitDefaultsDeviceCommandDescription();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.DeviceCommandDescription)
}
DeviceCommandDescription::DeviceCommandDescription(const DeviceCommandDescription& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  parameters_.MergeFrom(from.parameters_);
  returnvalues_.MergeFrom(from.returnvalues_);
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.name().size() > 0) {
    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.DeviceCommandDescription)
}

void DeviceCommandDescription::SharedCtor() {
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

DeviceCommandDescription::~DeviceCommandDescription() {
  // @@protoc_insertion_point(destructor:mascot.DeviceCommandDescription)
  SharedDtor();
}

void DeviceCommandDescription::SharedDtor() {
  name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void DeviceCommandDescription::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* DeviceCommandDescription::descriptor() {
  ::protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const DeviceCommandDescription& DeviceCommandDescription::default_instance() {
  ::protobuf_device_2eproto::InitDefaultsDeviceCommandDescription();
  return *internal_default_instance();
}

DeviceCommandDescription* DeviceCommandDescription::New(::google::protobuf::Arena* arena) const {
  DeviceCommandDescription* n = new DeviceCommandDescription;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void DeviceCommandDescription::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.DeviceCommandDescription)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  parameters_.Clear();
  returnvalues_.Clear();
  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool DeviceCommandDescription::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.DeviceCommandDescription)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string name = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_name()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->name().data(), static_cast<int>(this->name().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceCommandDescription.name"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // map<string, .mascot.CmdArgType> parameters = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DeviceCommandDescription_ParametersEntry_DoNotUse::Parser< ::google::protobuf::internal::MapField<
              DeviceCommandDescription_ParametersEntry_DoNotUse,
              ::std::string, ::mascot::CmdArgType,
              ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
              ::google::protobuf::internal::WireFormatLite::TYPE_ENUM,
              0 >,
            ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType > > parser(&parameters_);
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
              input, &parser));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            parser.key().data(), static_cast<int>(parser.key().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceCommandDescription.ParametersEntry.key"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // map<string, .mascot.CmdArgType> returnValues = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(26u /* 26 & 0xFF */)) {
          DeviceCommandDescription_ReturnValuesEntry_DoNotUse::Parser< ::google::protobuf::internal::MapField<
              DeviceCommandDescription_ReturnValuesEntry_DoNotUse,
              ::std::string, ::mascot::CmdArgType,
              ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
              ::google::protobuf::internal::WireFormatLite::TYPE_ENUM,
              0 >,
            ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType > > parser(&returnvalues_);
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessageNoVirtual(
              input, &parser));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            parser.key().data(), static_cast<int>(parser.key().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.DeviceCommandDescription.ReturnValuesEntry.key"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.DeviceCommandDescription)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.DeviceCommandDescription)
  return false;
#undef DO_
}

void DeviceCommandDescription::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.DeviceCommandDescription)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceCommandDescription.name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->name(), output);
  }

  // map<string, .mascot.CmdArgType> parameters = 2;
  if (!this->parameters().empty()) {
    typedef ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::google::protobuf::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceCommandDescription.ParametersEntry.key");
      }
    };

    if (output->IsSerializationDeterministic() &&
        this->parameters().size() > 1) {
      ::google::protobuf::scoped_array<SortItem> items(
          new SortItem[this->parameters().size()]);
      typedef ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::size_type size_type;
      size_type n = 0;
      for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
          it = this->parameters().begin();
          it != this->parameters().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      ::google::protobuf::scoped_ptr<DeviceCommandDescription_ParametersEntry_DoNotUse> entry;
      for (size_type i = 0; i < n; i++) {
        entry.reset(parameters_.NewEnumEntryWrapper(
            items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second));
        ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
            2, *entry, output);
        Utf8Check::Check(items[static_cast<ptrdiff_t>(i)]);
      }
    } else {
      ::google::protobuf::scoped_ptr<DeviceCommandDescription_ParametersEntry_DoNotUse> entry;
      for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
          it = this->parameters().begin();
          it != this->parameters().end(); ++it) {
        entry.reset(parameters_.NewEnumEntryWrapper(
            it->first, it->second));
        ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
            2, *entry, output);
        Utf8Check::Check(&*it);
      }
    }
  }

  // map<string, .mascot.CmdArgType> returnValues = 3;
  if (!this->returnvalues().empty()) {
    typedef ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::google::protobuf::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceCommandDescription.ReturnValuesEntry.key");
      }
    };

    if (output->IsSerializationDeterministic() &&
        this->returnvalues().size() > 1) {
      ::google::protobuf::scoped_array<SortItem> items(
          new SortItem[this->returnvalues().size()]);
      typedef ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::size_type size_type;
      size_type n = 0;
      for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
          it = this->returnvalues().begin();
          it != this->returnvalues().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      ::google::protobuf::scoped_ptr<DeviceCommandDescription_ReturnValuesEntry_DoNotUse> entry;
      for (size_type i = 0; i < n; i++) {
        entry.reset(returnvalues_.NewEnumEntryWrapper(
            items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second));
        ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
            3, *entry, output);
        Utf8Check::Check(items[static_cast<ptrdiff_t>(i)]);
      }
    } else {
      ::google::protobuf::scoped_ptr<DeviceCommandDescription_ReturnValuesEntry_DoNotUse> entry;
      for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
          it = this->returnvalues().begin();
          it != this->returnvalues().end(); ++it) {
        entry.reset(returnvalues_.NewEnumEntryWrapper(
            it->first, it->second));
        ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
            3, *entry, output);
        Utf8Check::Check(&*it);
      }
    }
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.DeviceCommandDescription)
}

::google::protobuf::uint8* DeviceCommandDescription::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.DeviceCommandDescription)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.DeviceCommandDescription.name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->name(), target);
  }

  // map<string, .mascot.CmdArgType> parameters = 2;
  if (!this->parameters().empty()) {
    typedef ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::google::protobuf::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceCommandDescription.ParametersEntry.key");
      }
    };

    if (deterministic &&
        this->parameters().size() > 1) {
      ::google::protobuf::scoped_array<SortItem> items(
          new SortItem[this->parameters().size()]);
      typedef ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::size_type size_type;
      size_type n = 0;
      for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
          it = this->parameters().begin();
          it != this->parameters().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      ::google::protobuf::scoped_ptr<DeviceCommandDescription_ParametersEntry_DoNotUse> entry;
      for (size_type i = 0; i < n; i++) {
        entry.reset(parameters_.NewEnumEntryWrapper(
            items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second));
        target = ::google::protobuf::internal::WireFormatLite::
                   InternalWriteMessageNoVirtualToArray(
                       2, *entry, deterministic, target);
;
        Utf8Check::Check(items[static_cast<ptrdiff_t>(i)]);
      }
    } else {
      ::google::protobuf::scoped_ptr<DeviceCommandDescription_ParametersEntry_DoNotUse> entry;
      for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
          it = this->parameters().begin();
          it != this->parameters().end(); ++it) {
        entry.reset(parameters_.NewEnumEntryWrapper(
            it->first, it->second));
        target = ::google::protobuf::internal::WireFormatLite::
                   InternalWriteMessageNoVirtualToArray(
                       2, *entry, deterministic, target);
;
        Utf8Check::Check(&*it);
      }
    }
  }

  // map<string, .mascot.CmdArgType> returnValues = 3;
  if (!this->returnvalues().empty()) {
    typedef ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_pointer
        ConstPtr;
    typedef ConstPtr SortItem;
    typedef ::google::protobuf::internal::CompareByDerefFirst<SortItem> Less;
    struct Utf8Check {
      static void Check(ConstPtr p) {
        ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
          p->first.data(), static_cast<int>(p->first.length()),
          ::google::protobuf::internal::WireFormatLite::SERIALIZE,
          "mascot.DeviceCommandDescription.ReturnValuesEntry.key");
      }
    };

    if (deterministic &&
        this->returnvalues().size() > 1) {
      ::google::protobuf::scoped_array<SortItem> items(
          new SortItem[this->returnvalues().size()]);
      typedef ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::size_type size_type;
      size_type n = 0;
      for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
          it = this->returnvalues().begin();
          it != this->returnvalues().end(); ++it, ++n) {
        items[static_cast<ptrdiff_t>(n)] = SortItem(&*it);
      }
      ::std::sort(&items[0], &items[static_cast<ptrdiff_t>(n)], Less());
      ::google::protobuf::scoped_ptr<DeviceCommandDescription_ReturnValuesEntry_DoNotUse> entry;
      for (size_type i = 0; i < n; i++) {
        entry.reset(returnvalues_.NewEnumEntryWrapper(
            items[static_cast<ptrdiff_t>(i)]->first, items[static_cast<ptrdiff_t>(i)]->second));
        target = ::google::protobuf::internal::WireFormatLite::
                   InternalWriteMessageNoVirtualToArray(
                       3, *entry, deterministic, target);
;
        Utf8Check::Check(items[static_cast<ptrdiff_t>(i)]);
      }
    } else {
      ::google::protobuf::scoped_ptr<DeviceCommandDescription_ReturnValuesEntry_DoNotUse> entry;
      for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
          it = this->returnvalues().begin();
          it != this->returnvalues().end(); ++it) {
        entry.reset(returnvalues_.NewEnumEntryWrapper(
            it->first, it->second));
        target = ::google::protobuf::internal::WireFormatLite::
                   InternalWriteMessageNoVirtualToArray(
                       3, *entry, deterministic, target);
;
        Utf8Check::Check(&*it);
      }
    }
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.DeviceCommandDescription)
  return target;
}

size_t DeviceCommandDescription::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.DeviceCommandDescription)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // map<string, .mascot.CmdArgType> parameters = 2;
  total_size += 1 *
      ::google::protobuf::internal::FromIntSize(this->parameters_size());
  {
    ::google::protobuf::scoped_ptr<DeviceCommandDescription_ParametersEntry_DoNotUse> entry;
    for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
        it = this->parameters().begin();
        it != this->parameters().end(); ++it) {
      entry.reset(parameters_.NewEnumEntryWrapper(it->first, it->second));
      total_size += ::google::protobuf::internal::WireFormatLite::
          MessageSizeNoVirtual(*entry);
    }
  }

  // map<string, .mascot.CmdArgType> returnValues = 3;
  total_size += 1 *
      ::google::protobuf::internal::FromIntSize(this->returnvalues_size());
  {
    ::google::protobuf::scoped_ptr<DeviceCommandDescription_ReturnValuesEntry_DoNotUse> entry;
    for (::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >::const_iterator
        it = this->returnvalues().begin();
        it != this->returnvalues().end(); ++it) {
      entry.reset(returnvalues_.NewEnumEntryWrapper(it->first, it->second));
      total_size += ::google::protobuf::internal::WireFormatLite::
          MessageSizeNoVirtual(*entry);
    }
  }

  // string name = 1;
  if (this->name().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->name());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void DeviceCommandDescription::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.DeviceCommandDescription)
  GOOGLE_DCHECK_NE(&from, this);
  const DeviceCommandDescription* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const DeviceCommandDescription>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.DeviceCommandDescription)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.DeviceCommandDescription)
    MergeFrom(*source);
  }
}

void DeviceCommandDescription::MergeFrom(const DeviceCommandDescription& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.DeviceCommandDescription)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  parameters_.MergeFrom(from.parameters_);
  returnvalues_.MergeFrom(from.returnvalues_);
  if (from.name().size() > 0) {

    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
}

void DeviceCommandDescription::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.DeviceCommandDescription)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void DeviceCommandDescription::CopyFrom(const DeviceCommandDescription& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.DeviceCommandDescription)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool DeviceCommandDescription::IsInitialized() const {
  return true;
}

void DeviceCommandDescription::Swap(DeviceCommandDescription* other) {
  if (other == this) return;
  InternalSwap(other);
}
void DeviceCommandDescription::InternalSwap(DeviceCommandDescription* other) {
  using std::swap;
  parameters_.Swap(&other->parameters_);
  returnvalues_.Swap(&other->returnvalues_);
  name_.Swap(&other->name_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata DeviceCommandDescription::GetMetadata() const {
  protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void CommandListReply::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int CommandListReply::kCommandsFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

CommandListReply::CommandListReply()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_device_2eproto::InitDefaultsCommandListReply();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.CommandListReply)
}
CommandListReply::CommandListReply(const CommandListReply& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      commands_(from.commands_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  // @@protoc_insertion_point(copy_constructor:mascot.CommandListReply)
}

void CommandListReply::SharedCtor() {
  _cached_size_ = 0;
}

CommandListReply::~CommandListReply() {
  // @@protoc_insertion_point(destructor:mascot.CommandListReply)
  SharedDtor();
}

void CommandListReply::SharedDtor() {
}

void CommandListReply::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* CommandListReply::descriptor() {
  ::protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const CommandListReply& CommandListReply::default_instance() {
  ::protobuf_device_2eproto::InitDefaultsCommandListReply();
  return *internal_default_instance();
}

CommandListReply* CommandListReply::New(::google::protobuf::Arena* arena) const {
  CommandListReply* n = new CommandListReply;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void CommandListReply::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.CommandListReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  commands_.Clear();
  _internal_metadata_.Clear();
}

bool CommandListReply::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.CommandListReply)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // repeated .mascot.DeviceCommandDescription commands = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(input, add_commands()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.CommandListReply)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.CommandListReply)
  return false;
#undef DO_
}

void CommandListReply::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.CommandListReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.DeviceCommandDescription commands = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->commands_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, this->commands(static_cast<int>(i)), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.CommandListReply)
}

::google::protobuf::uint8* CommandListReply::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.CommandListReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // repeated .mascot.DeviceCommandDescription commands = 1;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->commands_size()); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        1, this->commands(static_cast<int>(i)), deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.CommandListReply)
  return target;
}

size_t CommandListReply::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.CommandListReply)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated .mascot.DeviceCommandDescription commands = 1;
  {
    unsigned int count = static_cast<unsigned int>(this->commands_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->commands(static_cast<int>(i)));
    }
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void CommandListReply::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.CommandListReply)
  GOOGLE_DCHECK_NE(&from, this);
  const CommandListReply* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const CommandListReply>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.CommandListReply)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.CommandListReply)
    MergeFrom(*source);
  }
}

void CommandListReply::MergeFrom(const CommandListReply& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.CommandListReply)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  commands_.MergeFrom(from.commands_);
}

void CommandListReply::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.CommandListReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void CommandListReply::CopyFrom(const CommandListReply& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.CommandListReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool CommandListReply::IsInitialized() const {
  return true;
}

void CommandListReply::Swap(CommandListReply* other) {
  if (other == this) return;
  InternalSwap(other);
}
void CommandListReply::InternalSwap(CommandListReply* other) {
  using std::swap;
  commands_.InternalSwap(&other->commands_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata CommandListReply::GetMetadata() const {
  protobuf_device_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_device_2eproto::file_level_metadata[kIndexInFileMessages];
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace mascot

// @@protoc_insertion_point(global_scope)
